lab_1/urls.py
from django.conf.urls import url
from .views import index
#url for app
urlpatterns = [
    url(r'^$', index, name='index'),
]

lab_7/urls.py
from django.conf.urls import url
from .views import index, add_friend, validate_npm, delete_friend, friend_list_json, friend_list

urlpatterns = [
     url(r'^$', index, name='index'),
     url(r'^add-friend/$', add_friend, name='add-friend'),
     url(r'^validate-npm/$', validate_npm, name='validate-npm'),
     url(r'^delete-friend/$', delete_friend, name='delete-friend'),
     url(r'^get-friend-list/$', friend_list_json, name='get-friend-list'),
     url(r'^friend-list/$', friend_list, name='friend-list'),
]

praktikum/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from django.views.generic import RedirectView
import lab_1.urls as lab_1
import lab_2.urls as lab_2
import lab_2_addon.urls as lab_2_addon
import lab_3.urls as lab_3
import lab_4.urls as lab_4
import lab_5.urls as lab_5
import lab_6.urls as lab_6
import lab_7.urls as lab_7
import lab_8.urls as lab_8
import lab_9.urls as lab_9
import lab_10.urls as lab_10

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^lab-1/', include(lab_1,namespace='lab-1')),
    url(r'^lab-2/', include(lab_2,namespace='lab-2')),
    url(r'^lab-2-addon/', include(lab_2_addon, namespace='lab-2-addon')),
    url(r'^lab-3/', include(lab_3, namespace='lab-3')),
    url(r'^lab-4/', include(lab_4, namespace='lab-4')),
    url(r'^lab-5/', include(lab_5, namespace='lab-5')),
    url(r'^lab-6/', include(lab_6, namespace='lab-6')),
    url(r'^lab-7/', include(lab_7, namespace='lab-7')),
    url(r'^lab-8/', include(lab_8, namespace='lab-8')),
    url(r'^$', RedirectView.as_view(url='/lab-8/', permanent=True), name='redirect_landing_page'),
    url(r'^lab-9/', include(lab_9, namespace='lab-9')),
    url(r'^lab-10/', include(lab_10, namespace='lab-10')),
    ]

lab_7/models.py
from django.db import models

class Friend(models.Model):
    friend_name = models.CharField(max_length=400)
    npm = models.CharField(max_length=250)
    added_at = models.DateField(auto_now_add=True)

    def as_dict(self):
        return {
            "id": self.id,
            "friend_name": self.friend_name,
            "npm": self.npm,
        }

class Mahasiswa(models.Model):
    mahasiswa_name = models.CharField(max_length=400)
    npm = models.CharField(max_length=250)

lab_7/views.py
from django.shortcuts import render
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
from django.http import HttpResponse, HttpResponseRedirect, JsonResponse
from django.views.decorators.csrf import csrf_exempt
from django.core import serializers
from django.forms.models import model_to_dict

from .models import Friend, Mahasiswa
from api_csui_helper.csui_helper import CSUIhelper
import os
import json

response = {}
csui_helper = CSUIhelper()

def index(request):
    # Page halaman menampilkan list mahasiswa yang ada
    # TODO berikan akses token dari backend dengan menggunakaan helper yang ada
    list_mahasiswa = csui_helper.instance.get_mahasiswa_list()

    for mahasiswa in list_mahasiswa:
        mahasiswaX = Mahasiswa(mahasiswa_name=mahasiswa['nama'], npm=mahasiswa['npm'])
        mahasiswaX.save()

    paginator = Paginator(list_mahasiswa, 25)
    mahasiwa_list = Mahasiswa.objects.all()
    page = request.GET.get('page')
    try:
        halaman = paginator.page(page)
    except PageNotAnInteger:
        # If page is not an integer, deliver first page.
        halaman = paginator.page(1)


    friend_list = Friend.objects.all()
    response = {"mahasiswa_list": halaman, "friend_list": friend_list}
    html = 'lab_7/lab_7.html'
    return render(request, html, response)

def friend_list(request):
    friend_list = Friend.objects.all()
    response['friend_list'] = friend_list
    html = 'lab_7/daftar_teman.html'
    return render(request, html, response)

def friend_list_json(request): # update
    friends = [obj.as_dict() for obj in Friend.objects.all()]
    return JsonResponse({"results": friends})

@csrf_exempt
def add_friend(request):
    if request.method == 'POST':
        name = request.POST['name']
        npm = request.POST['npm']
        valid = isNpmValid(npm)
        data = {'validity' : valid}
        if data['validity'] == True:
            friend = Friend(friend_name=name, npm=npm)
            friend.save()
            data['friends'] = model_to_dict(friend)
        return JsonResponse(data)

@csrf_exempt
def delete_friend(request):
    if request.method == 'POST':
        friend_id = request.POST['id']
        Friend.objects.filter(id=friend_id).delete()
        response = {'id' : friend_id}
        return JsonResponse(response)

@csrf_exempt
def validate_npm(npm):
    data = {'is_taken': not isNpmValid(npm)}
    return JsonResponse(data)

def isNpmValid(npm):
    friends = Friend.objects.all()
    for friend in friends:
        if friend.npm == npm:
            return False
    return True

# def model_to_dict(obj):
#     data = serializers.serialize('json', [obj,])
#     struct = json.loads(data)
#     data = json.dumps(struct[0]["fields"])
#     return data

lab_7/templates/lab_7/daftar_teman.html
{% extends "lab_7/layout/base.html" %}

{% block content %}
    <section name="friend-list" id="friend-list">
        <div class="container">
            <div class="row">
                <div class="col-md-8 col-lg-8">
                    <h2> Friend Fasilkom</h2>
                    <div id="friend-list" class="list-group">

                    </div>
                </div>
            </div>
        </div>
    </section>
{% endblock %}
{% block javascript %}
    <script>
        $( document ).ready(function () {
            {# lengkapi pemanggilan ajax berikut untuk mengambil daftar teman yang ada di database #}
            $.ajax({
                method: "GET",
                url: "{% url 'lab-7:get-friend-list' %}", // update
                success: function(response) {
                   list_teman = response['results']
                   for(var i = 0; i < list_teman.length; i++){
                     teman = list_teman[i];
                     nama = '<a class="list-group-item clearfix" id="' + teman.id + '">' + teman.friend_name + ' ('+ teman.npm +')'
                     '</a>';
                     console.log(teman);
                     button = '<button type="button" class="btn btn-info" onClick="deleteFriend('+teman.id+')">Delete</button>'

                     $('#friend-list').append(nama+button);
                   }


                },
                error: function(error){
                }
            });
        });
        var deleteFriend = function(id) {
            $.ajax({
                method: 'POST',
                url: "{% url 'lab-7:delete-friend' %}",
                data: {'id': id},
                dataType : 'json',
                success : function (response) {
                  console.log("success");
                  console.log(response);
                    $('#'+response.id).hide();
                },
                error : function (error) {
                    alert("tadaaa")
                },
            });
        };
    </script>
{% endblock %}

lab_7/templates/lab_7/lab_7.html
{% extends "lab_7/layout/base.html" %}
{% block content %}
<section name="mahasiswa-list" id="mahasiswa-list">
    <div class="container">
        <div class="row">
            <div class="col-md-8 col-lg-8">
                <h2> Mahasiswa Fasilkom</h2>
                <div class="list-group">
                    {% if mahasiswa_list %}
                        {% for mahasiswa in mahasiswa_list %}
                            <a class="list-group-item clearfix">
                                {{ mahasiswa.nama }} ({{ mahasiswa.npm }})
                                <span class="pull-right">
                        <span class="btn btn-xs btn-default" onClick="addFriend('{{ mahasiswa.nama }}', '{{ mahasiswa.npm }}')">
                            Tambah sebagai teman
                        </span>
                    </span>
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Opps!</strong> Tidak ada mahasiswa
                        </div>
                    {% endif %}
                </div>

            <div class="pagination">
                <span class="step-links">
                    {% if mahasiswa_list.has_previous %}
                        <a href="?page={{ mahasiswa_list.previous_page_number }}">previous</a>
                    {% endif %}

                    <span class="current">
                        Page {{ mahasiswa_list.number }} of {{ mahasiswa_list.paginator.num_pages }}.
                    </span>

                    {% if mahasiswa_list.has_next %}
                        <a href="?page={{ mahasiswa_list.next_page_number }}">next</a>
                    {% endif %}
                </span>
            </div>

            </div>
            <div class="col-lg-4">
                <h2> Teman Saya </h2>
                <div class="list-group" id="friend-list">
                    {% if friend_list %}
                        {% for friend in friend_list %}
                            <a class="list-group-item clearfix">
                                {{ friend.friend_name }} ({{ friend.npm }})
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Opps!</strong> Tidak ada teman
                        </div>
                    {% endif %}
                </div>
                <form id="add-friend" action="#">
                    {% csrf_token %}
                    <label for="field_npm">npm</label>
                    <input id="field_npm" type="text" name="npm" class="form-control"/>
                    <label for="field_name">name</label>
                    <input id="field_name" type="text" name="name" class="form-control"/>
                    <button type="submit">Tambah</button>
                </form>
            </div>
        </div>
    </div>
</section>
{% endblock %}

{% block javascript %}
<script>
    var addFriend = function(nama, npm) {
        $.ajax({
            method: "POST",
            url: "{% url "lab-7:add-friend" %}",
            data: { name: nama, npm: npm},
            success : function (friend) {
              console.log(friend);
              if (friend.validity){
                html = '<a class="list-group-item clearfix">' +
                    friend.friends.friend_name + ' (' + friend.friends.npm + ')'
                    '</a>';
                $("#friend-list").append(html)
              } else{
                alert("Mahasiswa sudah ada");
              }

            },
            error : function (error) {
                alert("Mahasiswa tersebut sudah ditambahkan sebagai teman")
            }
        });
    };

    $("#add-friend").on("submit", function () {
       name = $("#field_name").val()
       npm = $("#field_npm").val()
        addFriend(name, npm)
        event.preventDefault();
    });

    $("#field_npm").change(function () {
        console.log( $(this).val() );
        npm = $(this).val();
        $.ajax({
            method: "POST",
            url: '{% url "lab-7:validate-npm" %}',
            data: {
                'npm': npm
            },
            dataType: 'json',
            success: function (data) {
                console.log(data)
                if (data.is_taken) {
                    alert("Mahasiswa dengan npm seperti ini sudah ada");
                }
            }
        });
    });
</script>
{% endblock %}